part of bcm2835_bindings;

Bcm2835Lib loadBcm2835Library(BinaryTypes types) {
  if (types == null) {
    throw new ArgumentError.notNull("types");
  }

  var operatingSystem = Platform.operatingSystem;
  String filename;
  switch (operatingSystem) {
    case "linux":
      filename = "libbcm2835.so";
      break;
    default:
      throw new StateError("Unsupported operating system: $operatingSystem");
  }

  var library = DynamicLibrary.load(filename, types: types);
  if (library == null) {
    throw new StateError("Unable to load library: $filename");
  }

  return new Bcm2835Lib(library);
}