part of bcm2835_bindings.headers;

/**
 * Based on C library for Broadcom BCM 2835 as used in Raspberry Pi (by Mike McCauley)
 * http://www.airspayce.com/mikem/bcm2835/index.html
 */
const String _BCM2835_H = """
#ifndef _BCM2835_H
#define _BCM2835_H

typedef enum
{
    BCM2835_REGBASE_ST   = 1,
    BCM2835_REGBASE_GPIO = 2,
    BCM2835_REGBASE_PWM  = 3,
    BCM2835_REGBASE_CLK  = 4,
    BCM2835_REGBASE_PADS = 5,
    BCM2835_REGBASE_SPI0 = 6,
    BCM2835_REGBASE_BSC0 = 7,
    BCM2835_REGBASE_BSC1 = 8
} bcm2835RegisterBase;

typedef enum
{
    BCM2835_GPIO_FSEL_INPT  = 0x00,
    BCM2835_GPIO_FSEL_OUTP  = 0x01,
    BCM2835_GPIO_FSEL_ALT0  = 0x04,
    BCM2835_GPIO_FSEL_ALT1  = 0x05,
    BCM2835_GPIO_FSEL_ALT2  = 0x06,
    BCM2835_GPIO_FSEL_ALT3  = 0x07,
    BCM2835_GPIO_FSEL_ALT4  = 0x03,
    BCM2835_GPIO_FSEL_ALT5  = 0x02,
    BCM2835_GPIO_FSEL_MASK  = 0x07
} bcm2835FunctionSelect;

typedef enum
{
    BCM2835_GPIO_PUD_OFF     = 0x00,
    BCM2835_GPIO_PUD_DOWN    = 0x01,
    BCM2835_GPIO_PUD_UP      = 0x02
} bcm2835PUDControl;

typedef enum
{
    BCM2835_PAD_GROUP_GPIO_0_27         = 0,
    BCM2835_PAD_GROUP_GPIO_28_45        = 1,
    BCM2835_PAD_GROUP_GPIO_46_53        = 2
} bcm2835PadGroup;

typedef enum
{
    RPI_GPIO_P1_03        =  0,
    RPI_GPIO_P1_05        =  1,
    RPI_GPIO_P1_07        =  4,
    RPI_GPIO_P1_08        = 14,
    RPI_GPIO_P1_10        = 15,
    RPI_GPIO_P1_11        = 17,
    RPI_GPIO_P1_12        = 18,
    RPI_GPIO_P1_13        = 21,
    RPI_GPIO_P1_15        = 22,
    RPI_GPIO_P1_16        = 23,
    RPI_GPIO_P1_18        = 24,
    RPI_GPIO_P1_19        = 10,
    RPI_GPIO_P1_21        =  9,
    RPI_GPIO_P1_22        = 25,
    RPI_GPIO_P1_23        = 11,
    RPI_GPIO_P1_24        =  8,
    RPI_GPIO_P1_26        =  7,

    RPI_V2_GPIO_P1_03     =  2,
    RPI_V2_GPIO_P1_05     =  3,
    RPI_V2_GPIO_P1_07     =  4,
    RPI_V2_GPIO_P1_08     = 14,
    RPI_V2_GPIO_P1_10     = 15,
    RPI_V2_GPIO_P1_11     = 17,
    RPI_V2_GPIO_P1_12     = 18,
    RPI_V2_GPIO_P1_13     = 27,
    RPI_V2_GPIO_P1_15     = 22,
    RPI_V2_GPIO_P1_16     = 23,
    RPI_V2_GPIO_P1_18     = 24,
    RPI_V2_GPIO_P1_19     = 10,
    RPI_V2_GPIO_P1_21     =  9,
    RPI_V2_GPIO_P1_22     = 25,
    RPI_V2_GPIO_P1_23     = 11,
    RPI_V2_GPIO_P1_24     =  8,
    RPI_V2_GPIO_P1_26     =  7,
    RPI_V2_GPIO_P1_29     =  5,
    RPI_V2_GPIO_P1_31     =  6,
    RPI_V2_GPIO_P1_32     = 12,
    RPI_V2_GPIO_P1_33     = 13,
    RPI_V2_GPIO_P1_35     = 19,
    RPI_V2_GPIO_P1_36     = 16,
    RPI_V2_GPIO_P1_37     = 26,
    RPI_V2_GPIO_P1_38     = 20,
    RPI_V2_GPIO_P1_40     = 21,

    RPI_V2_GPIO_P5_03     = 28,
    RPI_V2_GPIO_P5_04     = 29,
    RPI_V2_GPIO_P5_05     = 30,
    RPI_V2_GPIO_P5_06     = 31,

    RPI_BPLUS_GPIO_J8_03     =  2,
    RPI_BPLUS_GPIO_J8_05     =  3,
    RPI_BPLUS_GPIO_J8_07     =  4,
    RPI_BPLUS_GPIO_J8_08     = 14,
    RPI_BPLUS_GPIO_J8_10     = 15,
    RPI_BPLUS_GPIO_J8_11     = 17,
    RPI_BPLUS_GPIO_J8_12     = 18,
    RPI_BPLUS_GPIO_J8_13     = 27,
    RPI_BPLUS_GPIO_J8_15     = 22,
    RPI_BPLUS_GPIO_J8_16     = 23,
    RPI_BPLUS_GPIO_J8_18     = 24,
    RPI_BPLUS_GPIO_J8_19     = 10,
    RPI_BPLUS_GPIO_J8_21     =  9,
    RPI_BPLUS_GPIO_J8_22     = 25,
    RPI_BPLUS_GPIO_J8_23     = 11,
    RPI_BPLUS_GPIO_J8_24     =  8,
    RPI_BPLUS_GPIO_J8_26     =  7,
    RPI_BPLUS_GPIO_J8_29     =  5,
    RPI_BPLUS_GPIO_J8_31     =  6,
    RPI_BPLUS_GPIO_J8_32     = 12,
    RPI_BPLUS_GPIO_J8_33     = 13,
    RPI_BPLUS_GPIO_J8_35     = 19,
    RPI_BPLUS_GPIO_J8_36     = 16,
    RPI_BPLUS_GPIO_J8_37     = 26,
    RPI_BPLUS_GPIO_J8_38     = 20,
    RPI_BPLUS_GPIO_J8_40     = 21
} RPiGPIOPin;

typedef enum
{
    BCM2835_SPI_BIT_ORDER_LSBFIRST = 0,
    BCM2835_SPI_BIT_ORDER_MSBFIRST = 1
}bcm2835SPIBitOrder;

typedef enum
{
    BCM2835_SPI_MODE0 = 0,
    BCM2835_SPI_MODE1 = 1,
    BCM2835_SPI_MODE2 = 2,
    BCM2835_SPI_MODE3 = 3
}bcm2835SPIMode;

typedef enum
{
    BCM2835_SPI_CS0 = 0,
    BCM2835_SPI_CS1 = 1,
    BCM2835_SPI_CS2 = 2,
    BCM2835_SPI_CS_NONE = 3
} bcm2835SPIChipSelect;

typedef enum
{
    BCM2835_SPI_CLOCK_DIVIDER_65536 = 0,
    BCM2835_SPI_CLOCK_DIVIDER_32768 = 32768,
    BCM2835_SPI_CLOCK_DIVIDER_16384 = 16384,
    BCM2835_SPI_CLOCK_DIVIDER_8192  = 8192,
    BCM2835_SPI_CLOCK_DIVIDER_4096  = 4096,
    BCM2835_SPI_CLOCK_DIVIDER_2048  = 2048,
    BCM2835_SPI_CLOCK_DIVIDER_1024  = 1024,
    BCM2835_SPI_CLOCK_DIVIDER_512   = 512,
    BCM2835_SPI_CLOCK_DIVIDER_256   = 256,
    BCM2835_SPI_CLOCK_DIVIDER_128   = 128,
    BCM2835_SPI_CLOCK_DIVIDER_64    = 64,
    BCM2835_SPI_CLOCK_DIVIDER_32    = 32,
    BCM2835_SPI_CLOCK_DIVIDER_16    = 16,
    BCM2835_SPI_CLOCK_DIVIDER_8     = 8,
    BCM2835_SPI_CLOCK_DIVIDER_4     = 4,
    BCM2835_SPI_CLOCK_DIVIDER_2     = 2,
    BCM2835_SPI_CLOCK_DIVIDER_1     = 1
} bcm2835SPIClockDivider;

typedef enum
{
    BCM2835_I2C_CLOCK_DIVIDER_2500   = 2500,
    BCM2835_I2C_CLOCK_DIVIDER_626    = 626,
    BCM2835_I2C_CLOCK_DIVIDER_150    = 150,
    BCM2835_I2C_CLOCK_DIVIDER_148    = 148
} bcm2835I2CClockDivider;

typedef enum
{
    BCM2835_I2C_REASON_OK   	     = 0x00,
    BCM2835_I2C_REASON_ERROR_NACK    = 0x01,
    BCM2835_I2C_REASON_ERROR_CLKT    = 0x02,
    BCM2835_I2C_REASON_ERROR_DATA    = 0x04
} bcm2835I2CReasonCodes;

typedef enum
{
    BCM2835_PWM_CLOCK_DIVIDER_2048  = 2048,
    BCM2835_PWM_CLOCK_DIVIDER_1024  = 1024,
    BCM2835_PWM_CLOCK_DIVIDER_512   = 512,
    BCM2835_PWM_CLOCK_DIVIDER_256   = 256,
    BCM2835_PWM_CLOCK_DIVIDER_128   = 128,
    BCM2835_PWM_CLOCK_DIVIDER_64    = 64,
    BCM2835_PWM_CLOCK_DIVIDER_32    = 32,
    BCM2835_PWM_CLOCK_DIVIDER_16    = 16,
    BCM2835_PWM_CLOCK_DIVIDER_8     = 8,
    BCM2835_PWM_CLOCK_DIVIDER_4     = 4,
    BCM2835_PWM_CLOCK_DIVIDER_2     = 2,
    BCM2835_PWM_CLOCK_DIVIDER_1     = 1
} bcm2835PWMClockDivider;

#endif
""";
