part of bcm2835_bindings.headers;

/**
 * Based on C library for Broadcom BCM 2835 as used in Raspberry Pi (by Mike McCauley)
 * http://www.airspayce.com/mikem/bcm2835/index.html
 */
const String _BCM2835_DEF_H = """
#ifndef _BCM2835_DEF_H
#define _BCM2835_DEF_H

#include<bcm2835.h>

#define HIGH 0x1
#define LOW  0x0

#define BCM2835_CORE_CLK_HZ 250000000

#define BMC2835_RPI2_DT_FILENAME "/proc/device-tree/soc/ranges"
#define BMC2835_RPI2_DT_PERI_BASE_ADDRESS_OFFSET 4
#define BMC2835_RPI2_DT_PERI_SIZE_OFFSET 8

#define BMC2835_RPI2_DT_FILENAME "/proc/device-tree/soc/ranges"
#define BMC2835_RPI2_DT_PERI_BASE_ADDRESS_OFFSET 4
#define BMC2835_RPI2_DT_PERI_SIZE_OFFSET 8

#define BCM2835_PERI_BASE 0x20000000
#define BCM2835_PERI_SIZE 0x01000000

#define BCM2835_ST_BASE    0x3000
#define BCM2835_GPIO_PADS  0x100000
#define BCM2835_CLOCK_BASE 0x101000
#define BCM2835_GPIO_BASE  0x200000
#define BCM2835_SPI0_BASE  0x204000
#define BCM2835_BSC0_BASE  0x205000
#define BCM2835_GPIO_PWM   0x20C000
#define BCM2835_BSC1_BASE	 0x804000

#define BCM2835_PAGE_SIZE               (4*1024)
#define BCM2835_BLOCK_SIZE              (4*1024)

#define BCM2835_GPFSEL0                      0x0000
#define BCM2835_GPFSEL1                      0x0004
#define BCM2835_GPFSEL2                      0x0008
#define BCM2835_GPFSEL3                      0x000c
#define BCM2835_GPFSEL4                      0x0010
#define BCM2835_GPFSEL5                      0x0014
#define BCM2835_GPSET0                       0x001c
#define BCM2835_GPSET1                       0x0020
#define BCM2835_GPCLR0                       0x0028
#define BCM2835_GPCLR1                       0x002c
#define BCM2835_GPLEV0                       0x0034
#define BCM2835_GPLEV1                       0x0038
#define BCM2835_GPEDS0                       0x0040
#define BCM2835_GPEDS1                       0x0044
#define BCM2835_GPREN0                       0x004c
#define BCM2835_GPREN1                       0x0050
#define BCM2835_GPFEN0                       0x0058
#define BCM2835_GPFEN1                       0x005c
#define BCM2835_GPHEN0                       0x0064
#define BCM2835_GPHEN1                       0x0068
#define BCM2835_GPLEN0                       0x0070
#define BCM2835_GPLEN1                       0x0074
#define BCM2835_GPAREN0                      0x007c
#define BCM2835_GPAREN1                      0x0080
#define BCM2835_GPAFEN0                      0x0088
#define BCM2835_GPAFEN1                      0x008c
#define BCM2835_GPPUD                        0x0094
#define BCM2835_GPPUDCLK0                    0x0098
#define BCM2835_GPPUDCLK1                    0x009c

#define BCM2835_PADS_GPIO_0_27               0x002c
#define BCM2835_PADS_GPIO_28_45              0x0030
#define BCM2835_PADS_GPIO_46_53              0x0034

#define BCM2835_PAD_PASSWRD                  (0x5A << 24)
#define BCM2835_PAD_SLEW_RATE_UNLIMITED      0x10
#define BCM2835_PAD_HYSTERESIS_ENABLED       0x08
#define BCM2835_PAD_DRIVE_2mA                0x00
#define BCM2835_PAD_DRIVE_4mA                0x01
#define BCM2835_PAD_DRIVE_6mA                0x02
#define BCM2835_PAD_DRIVE_8mA                0x03
#define BCM2835_PAD_DRIVE_10mA               0x04
#define BCM2835_PAD_DRIVE_12mA               0x05
#define BCM2835_PAD_DRIVE_14mA               0x06
#define BCM2835_PAD_DRIVE_16mA               0x07

#define BCM2835_SPI0_CS                      0x0000
#define BCM2835_SPI0_FIFO                    0x0004
#define BCM2835_SPI0_CLK                     0x0008
#define BCM2835_SPI0_DLEN                    0x000c
#define BCM2835_SPI0_LTOH                    0x0010
#define BCM2835_SPI0_DC                      0x0014

#define BCM2835_SPI0_CS_LEN_LONG             0x02000000
#define BCM2835_SPI0_CS_DMA_LEN              0x01000000
#define BCM2835_SPI0_CS_CSPOL2               0x00800000
#define BCM2835_SPI0_CS_CSPOL1               0x00400000
#define BCM2835_SPI0_CS_CSPOL0               0x00200000
#define BCM2835_SPI0_CS_RXF                  0x00100000
#define BCM2835_SPI0_CS_RXR                  0x00080000
#define BCM2835_SPI0_CS_TXD                  0x00040000
#define BCM2835_SPI0_CS_RXD                  0x00020000
#define BCM2835_SPI0_CS_DONE                 0x00010000
#define BCM2835_SPI0_CS_TE_EN                0x00008000
#define BCM2835_SPI0_CS_LMONO                0x00004000
#define BCM2835_SPI0_CS_LEN                  0x00002000
#define BCM2835_SPI0_CS_REN                  0x00001000
#define BCM2835_SPI0_CS_ADCS                 0x00000800
#define BCM2835_SPI0_CS_INTR                 0x00000400
#define BCM2835_SPI0_CS_INTD                 0x00000200
#define BCM2835_SPI0_CS_DMAEN                0x00000100
#define BCM2835_SPI0_CS_TA                   0x00000080
#define BCM2835_SPI0_CS_CSPOL                0x00000040
#define BCM2835_SPI0_CS_CLEAR                0x00000030
#define BCM2835_SPI0_CS_CLEAR_RX             0x00000020
#define BCM2835_SPI0_CS_CLEAR_TX             0x00000010
#define BCM2835_SPI0_CS_CPOL                 0x00000008
#define BCM2835_SPI0_CS_CPHA                 0x00000004
#define BCM2835_SPI0_CS_CS                   0x00000003

#define BCM2835_BSC_C 							0x0000
#define BCM2835_BSC_S 			0x0004
#define BCM2835_BSC_DLEN		0x0008
#define BCM2835_BSC_A 			0x000c
#define BCM2835_BSC_FIFO		0x0010
#define BCM2835_BSC_DIV			0x0014
#define BCM2835_BSC_DEL			0x0018
#define BCM2835_BSC_CLKT		0x001c

#define BCM2835_BSC_C_I2CEN 		0x00008000
#define BCM2835_BSC_C_INTR 		0x00000400
#define BCM2835_BSC_C_INTT 		0x00000200
#define BCM2835_BSC_C_INTD 		0x00000100
#define BCM2835_BSC_C_ST 		0x00000080
#define BCM2835_BSC_C_CLEAR_1 		0x00000020
#define BCM2835_BSC_C_CLEAR_2 		0x00000010
#define BCM2835_BSC_C_READ 		0x00000001

#define BCM2835_BSC_S_CLKT 		0x00000200
#define BCM2835_BSC_S_ERR 		0x00000100
#define BCM2835_BSC_S_RXF 		0x00000080
#define BCM2835_BSC_S_TXE 		0x00000040
#define BCM2835_BSC_S_RXD 		0x00000020
#define BCM2835_BSC_S_TXD 		0x00000010
#define BCM2835_BSC_S_RXR 		0x00000008
#define BCM2835_BSC_S_TXW 		0x00000004
#define BCM2835_BSC_S_DONE 		0x00000002
#define BCM2835_BSC_S_TA 		0x00000001

#define BCM2835_BSC_FIFO_SIZE   	16

#define BCM2835_ST_CS 			0x0000
#define BCM2835_ST_CLO 			0x0004
#define BCM2835_ST_CHI 			0x0008

#define BCM2835_PWM_CONTROL 0
#define BCM2835_PWM_STATUS  1
#define BCM2835_PWM_DMAC    2
#define BCM2835_PWM0_RANGE  4
#define BCM2835_PWM0_DATA   5
#define BCM2835_PWM_FIF1    6
#define BCM2835_PWM1_RANGE  8
#define BCM2835_PWM1_DATA   9

#define BCM2835_PWMCLK_CNTL     40
#define BCM2835_PWMCLK_DIV      41
#define BCM2835_PWM_PASSWRD     (0x5A << 24)

#define BCM2835_PWM1_MS_MODE    0x8000
#define BCM2835_PWM1_USEFIFO    0x2000
#define BCM2835_PWM1_REVPOLAR   0x1000
#define BCM2835_PWM1_OFFSTATE   0x0800
#define BCM2835_PWM1_REPEATFF   0x0400
#define BCM2835_PWM1_SERIAL     0x0200
#define BCM2835_PWM1_ENABLE     0x0100

#define BCM2835_PWM0_MS_MODE    0x0080
#define BCM2835_PWM_CLEAR_FIFO  0x0040
#define BCM2835_PWM0_USEFIFO    0x0020
#define BCM2835_PWM0_REVPOLAR   0x0010
#define BCM2835_PWM0_OFFSTATE   0x0008
#define BCM2835_PWM0_REPEATFF   0x0004
#define BCM2835_PWM0_SERIAL     0x0002
#define BCM2835_PWM0_ENABLE     0x0001

#endif
""";
